"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var inversify_1 = require("inversify");
var rootComponent_1 = require("../shared/rootComponent");
var tooltipService_1 = require("../shared/tooltipService");
var Clipboard = require("clipboard");
var codeService_1 = require("../shared/codeService");
var ArticleComponent = /** @class */ (function (_super) {
    __extends(ArticleComponent, _super);
    function ArticleComponent(tooltipService, codeService) {
        var _this = _super.call(this) || this;
        _this._tooltipService = tooltipService;
        _this._codeService = codeService;
        return _this;
    }
    ArticleComponent.prototype.enabled = function () {
        // Always exists
        return true;
    };
    ArticleComponent.prototype.setupImmediate = function () {
        this._codeService.setupCodeBlocks();
    };
    ArticleComponent.prototype.setupOnLoad = function () {
    };
    ArticleComponent.prototype.validDomElementExists = function () {
        // Article always exists
        return true;
    };
    ArticleComponent.prototype.setupOnDomContentLoaded = function () {
        this.setupSectionHeaderLinks();
    };
    ArticleComponent.prototype.setupSectionHeaderLinks = function () {
        var articleElement = document.querySelector('.main-article');
        var sectionElements = articleElement.querySelectorAll('section[class*="flexi-section-block-"]');
        for (var i = 0; i < sectionElements.length; i++) {
            var sectionElement = sectionElements[i];
            var buttonElement = sectionElement.querySelector('button');
            var id = sectionElement.getAttribute('id');
            var href = location.protocol + "//" + location.host + location.pathname + "#" + id;
            // Clipboard for button
            buttonElement.setAttribute('data-clipboard-text', href);
            new Clipboard(buttonElement);
            // 'Popup' for button
            buttonElement.setAttribute('title', 'Link copied');
            this._tooltipService.setupElement(buttonElement, 'right');
        }
    };
    ArticleComponent = __decorate([
        inversify_1.injectable(),
        __metadata("design:paramtypes", [tooltipService_1.default,
            codeService_1.default])
    ], ArticleComponent);
    return ArticleComponent;
}(rootComponent_1.default));
exports.default = ArticleComponent;
//# sourceMappingURL=articleComponent.js.map