import RootComponent from '../shared/rootComponent';
import MediaGlobalService from '../shared/mediaGlobalService';
import OverlayService from '../shared/overlayService';
import DropdownFactory from '../shared/dropdownFactory';
import DebounceService from '../shared/debounceService';
import OutlineComponent from './outlineComponent';
import ArticleLinksComponent from './articleLinksComponent';
import ArticleMenuHeaderComponent from './articleMenuHeaderComponent';
export default class ArticleMenuComponent extends RootComponent {
    private _articleMenuElement;
    private _linksAndTocOuterWrapperElement;
    private _linksAndTocInnerWrapperElement;
    private _headerButtonElement;
    private _footerElement;
    private _outlineScrollable;
    private _outlineComponent;
    private _mediaGlobalService;
    private _overlayService;
    private _debounceService;
    private _dropdownFactory;
    private static readonly VERTICAL_GAP;
    private static readonly HEADER_HEIGHT;
    private static readonly DEBOUNCE_TIME;
    private _dropdown;
    private _bodyResizeObserver;
    private _linksAndOutlineLevel1Height;
    private _updateSideMenuQueued;
    private _menuMode;
    constructor(mediaGlobalService: MediaGlobalService, outlineComponent: OutlineComponent, articleLinksComponent: ArticleLinksComponent, articleMenuHeaderComponent: ArticleMenuHeaderComponent, debounceService: DebounceService, overlayService: OverlayService, dropdownFactory: DropdownFactory);
    setupImmediate(): void;
    enabled(): boolean;
    setupOnDomContentLoaded(): void;
    setupOnLoad(): void;
    private overlayClickListener;
    private buttonClickListener;
    private outlineAnchorClickListener;
    private onChangedToDropdownListener;
    private onChangedToSideMenuListener;
    private updateDropdown;
    private resetDropdown;
    private updateSideMenu;
    private resetSideMenu;
    private updateSideMenuDeferred;
}
