"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
var inversify_1 = require("inversify");
var articleGlobalService_1 = require("../shared/articleGlobalService");
var mediaGlobalService_1 = require("../shared/mediaGlobalService");
var mediaWidth_1 = require("../shared/mediaWidth");
var ArticleMenuHeaderComponent = /** @class */ (function () {
    function ArticleMenuHeaderComponent(articleGlobalService, mediaGlobalService) {
        var _this = this;
        this.onChangedToNarrowListener = function () {
            // While article menu is a side menu, text isn't updated. When article menu becomes a dropdown, it must be updated manually
            _this._articleGlobalService.addActiveSectionChangedListener(_this.updateText, true);
        };
        this.onChangedFromNarrowListener = function (init) {
            if (!init) {
                _this._articleGlobalService.removeActiveSectionChangedListener(_this.updateText);
            }
        };
        this.updateText = function (activeSectionIndex) {
            var textData = _this._textData[activeSectionIndex];
            _this._text1Element.innerText = textData.part1;
            if (textData.part2) {
                _this._text2Element.innerText = textData.part2;
                _this._text2Element.parentElement.style.display = 'flex';
            }
            else {
                _this._text2Element.parentElement.style.display = 'none';
            }
        };
        this._mediaGlobalService = mediaGlobalService;
        this._articleGlobalService = articleGlobalService;
    }
    ArticleMenuHeaderComponent.prototype.setupImmediate = function () {
        this._text1Element = document.getElementById('article-menu-header-text-1');
        this._text2Element = document.getElementById('article-menu-header-text-2');
        this._textData = [];
        this.setupText();
    };
    ArticleMenuHeaderComponent.prototype.setupOnDomContentLoaded = function () {
    };
    ArticleMenuHeaderComponent.prototype.setupOnLoad = function () {
        this._mediaGlobalService.addChangedToListener(this.onChangedToNarrowListener, mediaWidth_1.MediaWidth.narrow);
        this._mediaGlobalService.addChangedFromListener(this.onChangedFromNarrowListener, mediaWidth_1.MediaWidth.narrow);
    };
    ArticleMenuHeaderComponent.prototype.setupText = function () {
        var currentPart1;
        var sectionElements = this._articleGlobalService.getSectionElements();
        for (var i = 0; i < sectionElements.length; i++) {
            var sectionElement = sectionElements[i];
            if (sectionElement.classList.contains('main-article')) {
                this._textData.push({ part1: 'Contents', part2: null });
            }
            else if (sectionElement.classList.contains('flexi-section-block-2')) {
                currentPart1 = sectionElement.firstElementChild.firstElementChild.textContent;
                this._textData.push({ part1: currentPart1, part2: null });
            }
            else {
                // level 3
                this._textData.push({ part1: currentPart1, part2: sectionElement.firstElementChild.firstElementChild.textContent });
            }
        }
    };
    ArticleMenuHeaderComponent = __decorate([
        inversify_1.injectable(),
        __param(0, inversify_1.inject('GlobalService')), __param(0, inversify_1.named('ArticleGlobalService')),
        __param(1, inversify_1.inject('GlobalService')), __param(1, inversify_1.named('MediaGlobalService')),
        __metadata("design:paramtypes", [articleGlobalService_1.default,
            mediaGlobalService_1.default])
    ], ArticleMenuHeaderComponent);
    return ArticleMenuHeaderComponent;
}());
exports.default = ArticleMenuHeaderComponent;
//# sourceMappingURL=articleMenuHeaderComponent.js.map