"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
var inversify_1 = require("inversify");
require("../shared/treeNode");
var articleGlobalService_1 = require("../shared/articleGlobalService");
var mediaGlobalService_1 = require("../shared/mediaGlobalService");
var mediaWidth_1 = require("../shared/mediaWidth");
var OutlineComponent = /** @class */ (function () {
    function OutlineComponent(articleGlobalService, mediaGlobalService) {
        var _this = this;
        this.onChangedToNarrowListener = function (init) {
            if (!init) {
                _this._articleGlobalService.removeActiveSectionChangedListener(_this.updateActiveSectionAnchor);
            }
        };
        this.onChangedFromNarrowListener = function () {
            _this._articleGlobalService.addActiveSectionChangedListener(_this.updateActiveSectionAnchor, true);
        };
        this.updateDropdownKnob = function () {
            var newIndex = _this._articleGlobalService.getActiveHeaderIndex();
            var activeDropdownAnchorIndex = newIndex === 0 ? 0 : newIndex - 1; // anchor elements does not include level 1 anchor
            if (activeDropdownAnchorIndex === _this._lastDropdownAnchorIndex) {
                return;
            }
            if (_this._lastDropdownAnchorIndex !== undefined) {
                _this._anchorElements[_this._lastDropdownAnchorIndex].classList.remove('active');
            }
            _this._anchorElements[activeDropdownAnchorIndex].classList.add('active');
            _this._lastDropdownAnchorIndex = activeDropdownAnchorIndex;
        };
        this.updateActiveSectionAnchor = function (newIndex) {
            var activeAnchorIndex = newIndex === 0 ? 0 : newIndex - 1; // anchor elements does not include level 1 anchor
            var activeAnchorElement = _this._anchorElements[activeAnchorIndex];
            var anchorBoundingRect = activeAnchorElement.getBoundingClientRect();
            var translateY = anchorBoundingRect.top - _this._outlineScrollableElement.getBoundingClientRect().top + _this._outlineScrollableElement.scrollTop;
            _this._knobElement.style.transform = "translateY(" + translateY + "px) scaleY(" + anchorBoundingRect.height + ")";
        };
        this._articleGlobalService = articleGlobalService;
        this._mediaGlobalService = mediaGlobalService;
    }
    OutlineComponent.prototype.setupImmediate = function () {
    };
    OutlineComponent.prototype.setupOnDomContentLoaded = function () {
        this._outlineScrollableElement = document.getElementById('outline-scrollable');
        this._knobElement = document.getElementById('outline-scrollable-knob');
        this._rootUnorderedListElement = document.querySelector('#outline ul');
        this._anchorElements = this._rootUnorderedListElement.querySelectorAll('a');
    };
    OutlineComponent.prototype.setupOnLoad = function () {
        this._mediaGlobalService.addChangedToListener(this.onChangedToNarrowListener, mediaWidth_1.MediaWidth.narrow);
        this._mediaGlobalService.addChangedFromListener(this.onChangedFromNarrowListener, mediaWidth_1.MediaWidth.narrow);
    };
    OutlineComponent.prototype.getAnchorElements = function () {
        return this._anchorElements;
    };
    OutlineComponent = __decorate([
        inversify_1.injectable(),
        __param(0, inversify_1.inject('GlobalService')), __param(0, inversify_1.named('ArticleGlobalService')),
        __param(1, inversify_1.inject('GlobalService')), __param(1, inversify_1.named('MediaGlobalService')),
        __metadata("design:paramtypes", [articleGlobalService_1.default,
            mediaGlobalService_1.default])
    ], OutlineComponent);
    return OutlineComponent;
}());
exports.default = OutlineComponent;
//# sourceMappingURL=outlineComponent.js.map