import RootComponent from '../shared/rootComponent';
import MediaGlobalService from '../shared/mediaGlobalService';
import OverlayService from '../shared/overlayService';
import CategoryPagesComponent from './categoryPagesComponent';
import CategoryPagesFilterComponent from './categoryPagesFilterComponent';
import DropdownFactory from '../shared/dropdownFactory';
import DebounceService from '../shared/debounceService';
export default class CategoryMenuComponent extends RootComponent {
    private _categoryMenuElement;
    private _headerButtonElement;
    private _pagesOuterWrapperElement;
    private _pagesInnerWrapperElement;
    private _footerElement;
    private _categoryPagesElement;
    private _mediaGlobalService;
    private _overlayService;
    private _debounceService;
    private _dropdownFactory;
    static readonly VERTICAL_GAP: number;
    private static readonly HEADER_HEIGHT;
    private static readonly DEBOUNCE_TIME;
    private _dropdown;
    private _bodyResizeObserver;
    private _updateSideMenuQueued;
    private _filterHeight;
    private _menuMode;
    constructor(mediaGlobalService: MediaGlobalService, debounceService: DebounceService, categoryPagesComponent: CategoryPagesComponent, categoryPagesFilterComponent: CategoryPagesFilterComponent, overlayService: OverlayService, dropdownFactory: DropdownFactory);
    enabled(): boolean;
    setupImmediate(): void;
    setupOnDomContentLoaded(): void;
    setupOnLoad(): void;
    private overlayClickListener;
    private buttonClickListener;
    private onChangedToDropdownListener;
    private onChangedToSideMenuListener;
    private updateDropdown;
    private resetDropdown;
    private updateSideMenu;
    private resetSideMenu;
    private updateSideMenuDeferred;
}
