"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var inversify_1 = require("inversify");
var textInputFactory_1 = require("../shared/textInputFactory");
var categoryPagesComponent_1 = require("./categoryPagesComponent");
var CategoryPagesFilterComponent = /** @class */ (function () {
    function CategoryPagesFilterComponent(categoryPagesComponent, textInputFactory) {
        var _this = this;
        this.onInputListener = function () {
            // Category pages' collapsible menu is only built after an ajax request returns the elements it contains.
            if (_this._categoryPagesComponent.collapsibleMenu) {
                var filterValue = _this._inputElement.value;
                if (filterValue === '') {
                    _this._categoryPagesComponent.collapsibleMenu.restorePreFilterState();
                    return;
                }
                if (!_this._categoryPagesElement.classList.contains('filtered')) {
                    _this._categoryPagesComponent.collapsibleMenu.savePreFilterState();
                    _this._categoryPagesElement.classList.add('filtered');
                }
                _this._categoryPagesComponent.collapsibleMenu.filter(filterValue);
            }
        };
        this._categoryPagesComponent = categoryPagesComponent;
        this._textInputFactory = textInputFactory;
    }
    CategoryPagesFilterComponent.prototype.setupOnDomContentLoaded = function () {
        var _this = this;
        this._categoryPagesElement = document.getElementById('category-pages');
        this._filterElement = document.getElementById('category-pages-filter');
        this._inputElement = this._filterElement.querySelector('input');
        this._clearElement = this._filterElement.querySelector('svg:last-child');
        this.
            _textInputFactory.
            build(this._filterElement, this._inputElement, this._clearElement, function () {
            if (_this._categoryPagesComponent.collapsibleMenu) {
                _this._categoryPagesComponent.collapsibleMenu.restorePreFilterState();
            }
        });
    };
    CategoryPagesFilterComponent.prototype.setupOnLoad = function () {
        this.
            _inputElement.
            addEventListener('input', this.onInputListener);
    };
    CategoryPagesFilterComponent.prototype.setupImmediate = function () {
        // Do nothing
    };
    CategoryPagesFilterComponent = __decorate([
        inversify_1.injectable(),
        __metadata("design:paramtypes", [categoryPagesComponent_1.default,
            textInputFactory_1.default])
    ], CategoryPagesFilterComponent);
    return CategoryPagesFilterComponent;
}());
exports.default = CategoryPagesFilterComponent;
//# sourceMappingURL=categoryPagesFilterComponent.js.map