"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var inversify_1 = require("inversify");
var rootComponent_1 = require("../shared/rootComponent");
var heightService_1 = require("../shared/heightService");
var CommentsComponent = /** @class */ (function (_super) {
    __extends(CommentsComponent, _super);
    function CommentsComponent(heightService) {
        var _this = _super.call(this) || this;
        _this.onIntersect = function (entries, _) {
            // Some browsers make an initial call to the callback, regardless of whether there is any intersection
            if (entries[0].intersectionRatio === 0) {
                return;
            }
            _this._spinner.classList.add('active');
            _this._intersectionObserver.disconnect();
            _this._intersectionObserver = null;
            var component = _this;
            window['disqus_config'] = function () {
                this.page.url = "https://" + location.host + location.pathname;
                this.page.identifier = component._disqusIdentifier;
                this.callbacks.onReady.push(component.disqusOnReady);
            };
            var disqusScript = document.createElement('script');
            disqusScript.src = "https://" + _this._disqusShortname + ".disqus.com/embed.js";
            disqusScript.setAttribute('data-timestamp', Date.now().toString());
            (document.head || document.body).appendChild(disqusScript);
            console.log('Disqus embed script inserted.');
        };
        _this.disqusOnReady = function () {
            var commentsLoader = document.getElementById('comments-loader');
            commentsLoader.style.opacity = '0';
            // Can't use transform here, need to trigger layouts so that footer gets pushed down
            _this._heightService.autoHeightToFixedHeightWithTransition(commentsLoader, 0);
            commentsLoader.addEventListener('transitionend', _this.commentsLoaderOnRemoved, true);
            // Disqus has some unusual behaviour whereby it it displays a login menu for a split 
            // second even if you are logged in (after the onready callback is called). This causes
            // an unavoidable jerk.
            _this._heightService.currentHeightToAutoHeightWithTransition(_this._disqusThreadElement);
        };
        _this.commentsLoaderOnRemoved = function (event) {
            if (event.target === event.currentTarget) {
                event.target.removeEventListener('transitionend', _this.commentsLoaderOnRemoved, true);
                event.target.style.display = 'none';
            }
            event.stopPropagation();
        };
        _this._heightService = heightService;
        return _this;
    }
    CommentsComponent.prototype.setupImmediate = function () {
        this._commentsElement = document.getElementById('comments');
        if (this.enabled()) {
            this._disqusThreadElement = document.getElementById('disqus_thread');
            this._spinner = document.getElementById('disqus-spinner');
        }
    };
    CommentsComponent.prototype.enabled = function () {
        return this._commentsElement ? true : false;
    };
    CommentsComponent.prototype.setupOnDomContentLoaded = function () {
        this._disqusShortname = this._disqusThreadElement.getAttribute('data-disqus-shortname');
        this._disqusIdentifier = this._disqusThreadElement.getAttribute('data-disqus-identifier');
    };
    CommentsComponent.prototype.setupOnLoad = function () {
        this._intersectionObserver = new IntersectionObserver(this.onIntersect);
        this._intersectionObserver.observe(this._commentsElement);
    };
    CommentsComponent = __decorate([
        inversify_1.injectable(),
        __metadata("design:paramtypes", [heightService_1.default])
    ], CommentsComponent);
    return CommentsComponent;
}(rootComponent_1.default));
exports.default = CommentsComponent;
//# sourceMappingURL=commentsComponent.js.map