"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var resize_observer_polyfill_1 = require("resize-observer-polyfill");
var inversify_1 = require("inversify");
var rootComponent_1 = require("../shared/rootComponent");
var debounceService_1 = require("../shared/debounceService");
var PageFooterComponent = /** @class */ (function (_super) {
    __extends(PageFooterComponent, _super);
    function PageFooterComponent(debounceService) {
        var _this = _super.call(this) || this;
        _this.updateViewportPlusMobileUrlBarHeight = function () {
            var overlayElementStyle = getComputedStyle(document.getElementById('overlay'));
            _this._viewportPlusMobileUrlBarHeight = parseFloat(overlayElementStyle.height);
        };
        _this.setBackToTopButtonVisibility = function () {
            var visible = _this._footerButtonElement.classList.contains('visible');
            // This is a hack for getting around android chrome and ios safari url bars.
            // - 100vh corresponds to the viewport height + the url bar height on both and is fixed - https://developers.google.com/web/updates/2016/12/url-bar-resizing.
            // - If body.offsetHeight is === (viewport height + url bar height), there will be no vertical scrollbar (if user attempts to scroll, url bar will scroll out). 
            // 100vh can only be obtained in js by setting an element's height to 100vh and retrieving its height through its computed style, this is done in updateViewportPlusMobileUrlBarHeight.
            var pageScrollable = document.body.offsetHeight > _this._viewportPlusMobileUrlBarHeight;
            if (!visible && pageScrollable) {
                _this._footerButtonElement.classList.add('visible');
            }
            else if (visible && !pageScrollable) {
                _this._footerButtonElement.classList.remove('visible');
            }
        };
        _this._debounceService = debounceService;
        return _this;
    }
    PageFooterComponent_1 = PageFooterComponent;
    PageFooterComponent.prototype.setupImmediate = function () {
        this._footerButtonElement = document.getElementById('page-footer-button');
    };
    PageFooterComponent.prototype.enabled = function () {
        // Footer always exists
        return true;
    };
    PageFooterComponent.prototype.setupOnDomContentLoaded = function () {
    };
    PageFooterComponent.prototype.setupOnLoad = function () {
        var documentElementResizeObserver = new resize_observer_polyfill_1.default(this.updateViewportPlusMobileUrlBarHeight);
        documentElementResizeObserver.observe(document.documentElement);
        // TODO one of the main reasons for using ResizeObserver is that it provides dimensions so layouts can be avoided - https://developers.google.com/web/updates/2016/10/resizeobserver
        // Utilize those values.
        var bodyResizeObserver = new resize_observer_polyfill_1.default(this._debounceService.createTimeoutDebounceFunction(this.setBackToTopButtonVisibility, PageFooterComponent_1.DEBOUNCE_DURATION));
        bodyResizeObserver.observe(document.body);
    };
    var PageFooterComponent_1;
    PageFooterComponent.DEBOUNCE_DURATION = 150;
    PageFooterComponent = PageFooterComponent_1 = __decorate([
        inversify_1.injectable(),
        __metadata("design:paramtypes", [debounceService_1.default])
    ], PageFooterComponent);
    return PageFooterComponent;
}(rootComponent_1.default));
exports.default = PageFooterComponent;
//# sourceMappingURL=pageFooterComponent.js.map