"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
var inversify_1 = require("inversify");
var rootComponent_1 = require("../shared/rootComponent");
var searchComponent_1 = require("./searchComponent");
var searchResultsComponent_1 = require("./searchResultsComponent");
var overlayService_1 = require("../shared/overlayService");
var mediaGlobalService_1 = require("../shared/mediaGlobalService");
var mediaWidth_1 = require("../shared/mediaWidth");
var dropdownFactory_1 = require("../shared/dropdownFactory");
var PageHeaderComponent = /** @class */ (function (_super) {
    __extends(PageHeaderComponent, _super);
    function PageHeaderComponent(mediaGlobalService, dropdownFactory, overlayService, searchComponent, searchResultsComponent) {
        var _this = _super.call(this) || this;
        _this.onChangedToNarrowListener = function () {
            if (_this._searchComponent.hasQuery()) {
                _this._dropdown.expandWithoutAnimation();
            }
        };
        _this.onChangedFromNarrowListener = function () {
            if (_this._dropdown.isExpanded() && !_this._searchComponent.hasQuery()) {
                _this._overlayService.deactivateOverlay(false);
            }
            _this._dropdown.reset();
        };
        _this.overlayClickListener = function () {
            if (_this._searchComponent.hasQuery()) {
                _this._searchComponent.reset();
            }
            if (_this._dropdown.isExpanded()) {
                _this._overlayService.deactivateOverlay();
                _this._dropdown.collapseWithAnimation();
            }
        };
        _this.buttonClickListener = function () {
            if (_this._dropdown.isExpanded()) {
                _this._searchComponent.reset();
                _this._overlayService.deactivateOverlay();
            }
            else {
                _this._overlayService.activateOverlay(_this._pageHeaderElement, false);
            }
            _this._dropdown.toggleWithAnimation();
        };
        _this._dropdownFactory = dropdownFactory;
        _this._overlayService = overlayService;
        _this._mediaGlobalService = mediaGlobalService;
        _this._searchComponent = searchComponent;
        _this.addChildComponents(searchComponent, searchResultsComponent);
        return _this;
    }
    PageHeaderComponent.prototype.enabled = function () {
        // Header always exists
        return true;
    };
    PageHeaderComponent.prototype.setupImmediate = function () {
        this.childComponentsSetupImmediate();
    };
    PageHeaderComponent.prototype.setupOnDomContentLoaded = function () {
        this.childComponentsSetupOnDomContentLoaded();
        this._buttonElement = document.getElementById('page-header-button');
        this._navbarAndSearchOuterWrapper = document.getElementById('page-header-navbar-and-search-outer-wrapper');
        this._navbarAndSearchInnerWrapper = document.getElementById('page-header-navbar-and-search-inner-wrapper');
        this._pageHeaderElement = document.getElementById('page-header');
        this._dropdown = this._dropdownFactory.build(this._navbarAndSearchOuterWrapper, this._navbarAndSearchInnerWrapper, this._buttonElement, undefined);
    };
    PageHeaderComponent.prototype.setupOnLoad = function () {
        this.childComponentsSetupOnLoad();
        this._buttonElement.addEventListener('click', this.buttonClickListener);
        this._overlayService.addClickListener(this.overlayClickListener);
        this._mediaGlobalService.addChangedFromListener(this.onChangedFromNarrowListener, mediaWidth_1.MediaWidth.narrow);
        this._mediaGlobalService.addChangedToListener(this.onChangedToNarrowListener, mediaWidth_1.MediaWidth.narrow);
    };
    PageHeaderComponent = __decorate([
        inversify_1.injectable(),
        __param(0, inversify_1.inject('GlobalService')), __param(0, inversify_1.named('MediaGlobalService')),
        __metadata("design:paramtypes", [mediaGlobalService_1.default,
            dropdownFactory_1.default,
            overlayService_1.default,
            searchComponent_1.default,
            searchResultsComponent_1.default])
    ], PageHeaderComponent);
    return PageHeaderComponent;
}(rootComponent_1.default));
exports.default = PageHeaderComponent;
//# sourceMappingURL=pageHeaderComponent.js.map