"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var inversify_1 = require("inversify");
var textInputFactory_1 = require("../shared/textInputFactory");
var searchResultsComponent_1 = require("./searchResultsComponent");
var searchService_1 = require("../shared/searchService");
var SearchComponent = /** @class */ (function () {
    function SearchComponent(textInputFactory, searchResultsComponent, searchService) {
        this._textInputFactory = textInputFactory;
        this._searchResultsComponent = searchResultsComponent;
        this._searchService = searchService;
    }
    SearchComponent.prototype.setupImmediate = function () {
        this._searchService.setupSearch();
    };
    SearchComponent.prototype.setupOnDomContentLoaded = function () {
        var _this = this;
        this._searchElement = document.getElementById('page-header-search');
        this._inputElement = this._searchElement.querySelector('input');
        this._clearElement = this._searchElement.querySelector('svg:last-child');
        this._textInput = this.
            _textInputFactory.
            build(this._searchElement, this._inputElement, this._clearElement, function () {
            // This is what search service calls when value is an empty string
            _this._searchResultsComponent.setShown(false);
        });
    };
    SearchComponent.prototype.setupOnLoad = function () {
        // Do nothing
    };
    SearchComponent.prototype.hasQuery = function () {
        return this._inputElement.value.length > 0;
    };
    SearchComponent.prototype.reset = function () {
        this._textInput.reset();
    };
    SearchComponent = __decorate([
        inversify_1.injectable(),
        __metadata("design:paramtypes", [textInputFactory_1.default,
            searchResultsComponent_1.default,
            searchService_1.default])
    ], SearchComponent);
    return SearchComponent;
}());
exports.default = SearchComponent;
//# sourceMappingURL=searchComponent.js.map