"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
var inversify_1 = require("inversify");
var Mark = require("mark.js");
var paginationService_1 = require("../shared/paginationService");
var overlayService_1 = require("../shared/overlayService");
var mediaGlobalService_1 = require("../shared/mediaGlobalService");
var mediaWidth_1 = require("../shared/mediaWidth");
var SearchResultsComponent = /** @class */ (function () {
    function SearchResultsComponent(mediaGlobalService, overlayService, paginationService) {
        var _this = this;
        this.setArticleElements = function (articleElements, queryString) {
            if (articleElements.length === 0) {
                // Hide article list
                _this._articleListElement.style.display = 'none';
                // Update search string message
                _this._searchStringMessageElement.textContent = "No results found for \"" + queryString + "\" ...";
                // Show and update results message
                _this._searchResultsMessageElement.style.display = 'flex';
                _this._searchResultsMessageElement.textContent = "Your search - \"" + queryString + "\" - did not match any articles";
            }
            else {
                // Update search string message
                _this._searchStringMessageElement.textContent = "Search results for \"" + queryString + "\" ...";
                // Hide results message
                _this._searchResultsMessageElement.style.display = 'none';
                // Show and update article list
                _this._articleListElement.style.display = 'flex';
                _this._paginationService.setupPagination(_this._paginationButtonsElement, _this._articleListItemsParentElement, articleElements, function () {
                    var marked = [];
                    queryString.
                        split(/\s+/).
                        forEach(function (word) {
                        if (word !== '' && marked.indexOf(word) === -1) {
                            var target = new Mark(_this._articleListItemsParentElement);
                            target.mark(word);
                            marked.push(word);
                        }
                    });
                });
            }
            _this.setShown(true);
        };
        this._paginationService = paginationService;
        this._mediaGlobalService = mediaGlobalService;
        this._overlayService = overlayService;
    }
    SearchResultsComponent.prototype.setupImmediate = function () {
        // Do nothing
    };
    SearchResultsComponent.prototype.setupOnDomContentLoaded = function () {
        this._pageHeaderElement = document.getElementById('page-header');
        this._searchResultsElement = document.getElementById('search-results');
        this._searchStringMessageElement = document.querySelector('#search-string > span');
        this._searchResultsMessageElement = document.querySelector('#search-results > span');
        this._articleListElement = this._searchResultsElement.querySelector('.article-list');
        this._paginationButtonsElement = this._searchResultsElement.querySelector('.pagination-buttons');
        this._articleListItemsParentElement = this._searchResultsElement.querySelector('.al-items');
    };
    SearchResultsComponent.prototype.setupOnLoad = function () {
        // Do nothing
    };
    SearchResultsComponent.prototype.setShown = function (shown) {
        if (this._shown === shown) {
            return;
        }
        if (shown) {
            this._searchResultsElement.style.display = 'flex';
            if (!this._mediaGlobalService.mediaWidthIs(mediaWidth_1.MediaWidth.narrow)) {
                this._overlayService.activateOverlay(this._pageHeaderElement, false, false);
            }
        }
        else {
            this._searchResultsElement.style.display = 'none';
            // Reset
            this._articleListItemsParentElement.innerHTML = '';
            if (!this._mediaGlobalService.mediaWidthIs(mediaWidth_1.MediaWidth.narrow)) {
                this._overlayService.deactivateOverlay(false);
            }
        }
        this._shown = shown;
    };
    SearchResultsComponent = __decorate([
        inversify_1.injectable(),
        __param(0, inversify_1.inject('GlobalService')), __param(0, inversify_1.named('MediaGlobalService')),
        __metadata("design:paramtypes", [mediaGlobalService_1.default,
            overlayService_1.default,
            paginationService_1.default])
    ], SearchResultsComponent);
    return SearchResultsComponent;
}());
exports.default = SearchResultsComponent;
//# sourceMappingURL=searchResultsComponent.js.map