import MediaGlobalService from './mediaGlobalService';
import DebounceService from './debounceService';
import GlobalService from './globalService';
export default class ArticleGlobalService implements GlobalService {
    private _mediaGlobalService;
    private _debounceService;
    private _noOutline;
    private _sectionElements;
    private _observedSectionDatas;
    private _sectionMarginTops;
    private _updateHistoryDebounced;
    private _sectionHashes;
    private _activeSectionIndexFixed;
    private _activeSectionChangedListeners;
    private _activeSectionIndex;
    private _narrowIntersectionObserver;
    private _mediumWideIntersectionObserver;
    private _smoothScroll;
    private _headerHeight;
    private _headerEnabled;
    private _narrowInterSectionListenerCorrected;
    constructor(mediaGlobalService: MediaGlobalService, debounceService: DebounceService);
    setupOnDomContentLoaded(): void;
    setupImmediate(): void;
    setupOnLoad(): void;
    private onChangedToNarrowListener;
    private createNarrowIntersectionObserver;
    private onChangedFromNarrowListener;
    private observeSections;
    private onIntersectionListener;
    addActiveSectionChangedListener(listener: (newIndex: number) => void, init?: boolean): void;
    removeActiveSectionChangedListener(listener: (newIndex: number) => void): void;
    private setupSectionMarginTops;
    getActiveHeaderIndex(): number;
    getSectionElements(): HTMLElement[];
    private setupSmoothScroll;
    private smoothScrollBefore;
    private setActiveSectionIndex;
    private smoothScrollAfter;
    private updateHistory;
}
