"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var inversify_1 = require("inversify");
var tooltipService_1 = require("./tooltipService");
var Clipboard = require("clipboard");
var CodeService = /** @class */ (function () {
    function CodeService(tooltipService) {
        this._tooltipService = tooltipService;
    }
    CodeService.prototype.setupCodeBlocks = function () {
        var codeBlockElements = document.querySelectorAll(".flexi-code-block");
        var _loop_1 = function (i) {
            var codeBlockElement = codeBlockElements[i];
            // Add id to code element so we can copy its contents using clipboard
            var codeElementID = "code-" + i;
            var codeElement = codeBlockElement.querySelector("code");
            codeElement.setAttribute("id", codeElementID);
            // Setup tippy for copy button
            var copyButtonElement = codeBlockElement.querySelector("button");
            copyButtonElement.setAttribute('title', 'Code copied');
            this_1._tooltipService.setupElement(copyButtonElement, 'left');
            // Setup copying to clipboard
            var code = "";
            var lineTextElements = codeElement.querySelectorAll('.line-text');
            var lineTextElementsLastIndex = lineTextElements.length - 1;
            lineTextElements.forEach(function (value, index) {
                code += value.innerText + (index == lineTextElementsLastIndex ? '' : '\n'); // innerText does not include pseudo element content
            });
            new Clipboard(copyButtonElement, {
                text: function () {
                    return code;
                },
            });
        };
        var this_1 = this;
        // On click "popups"
        for (var i = 0; i < codeBlockElements.length; i++) {
            _loop_1(i);
        }
    };
    CodeService = __decorate([
        inversify_1.injectable(),
        __metadata("design:paramtypes", [tooltipService_1.default])
    ], CodeService);
    return CodeService;
}());
exports.default = CodeService;
//# sourceMappingURL=codeService.js.map