"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var inversify_1 = require("inversify");
//import EasingService from "./easingService";
var Dropdown = /** @class */ (function () {
    function Dropdown(contentOuterWrapperElement, contentInnerWrapperElement, toggleElement, headerAndContentWrapperElement) {
        this._contentOuterWrapperElement = contentOuterWrapperElement;
        this._contentInnerWrapperElement = contentInnerWrapperElement;
        this._toggleElement = toggleElement;
        this._headerAndContentWrapperElement = headerAndContentWrapperElement;
    }
    Dropdown.prototype.toggleWithAnimation = function (translateToTop) {
        if (translateToTop === void 0) { translateToTop = true; }
        if (this._toggleElement.classList.contains('expanded')) {
            this.collapseWithAnimation();
        }
        else {
            this.expandWithAnimation(translateToTop);
        }
    };
    Dropdown.prototype.expandWithAnimation = function (translateToTop) {
        if (translateToTop && this._headerAndContentWrapperElement) {
            this._headerAndContentWrapperElement.style.transition = '';
            var headerAndContentWrapperInitialTop = this._headerAndContentWrapperElement.getBoundingClientRect().top;
            this._headerAndContentWrapperElement.style.transform = "translateY(" + -headerAndContentWrapperInitialTop + "px)";
        }
        this._contentOuterWrapperElement.style.animationName = 'expandAnimation';
        this._contentInnerWrapperElement.style.animationName = 'expandInverseAnimation';
        this._toggleElement.classList.add('expanded');
    };
    Dropdown.prototype.collapseWithAnimation = function () {
        if (this._headerAndContentWrapperElement) {
            this._headerAndContentWrapperElement.style.transition = '';
            this._headerAndContentWrapperElement.style.transform = 'translateY(0)';
        }
        this._contentOuterWrapperElement.style.animationName = 'collapseAnimation';
        this._contentInnerWrapperElement.style.animationName = 'collapseInverseAnimation';
        this._toggleElement.classList.remove('expanded');
    };
    Dropdown.prototype.toggleWithoutAnimation = function (translateToTop) {
        if (translateToTop === void 0) { translateToTop = true; }
        if (this._toggleElement.classList.contains('expanded')) {
            this.collapseWithoutAnimation();
        }
        else {
            this.expandWithoutAnimation(translateToTop);
        }
    };
    Dropdown.prototype.expandWithoutAnimation = function (translateToTop) {
        if (translateToTop === void 0) { translateToTop = true; }
        if (translateToTop && this._headerAndContentWrapperElement) {
            this._headerAndContentWrapperElement.style.transition = 'initial';
            var headerAndContentWrapperInitialTop = this._headerAndContentWrapperElement.getBoundingClientRect().top;
            this._headerAndContentWrapperElement.style.transform = "translateY(" + -headerAndContentWrapperInitialTop + "px)";
        }
        this._contentOuterWrapperElement.style.animationName = '';
        this._contentInnerWrapperElement.style.animationName = '';
        this._contentOuterWrapperElement.style.transform = 'scaleY(1)';
        this._contentInnerWrapperElement.style.transform = 'scaleY(1)';
        this._toggleElement.classList.add('expanded');
    };
    Dropdown.prototype.collapseWithoutAnimation = function () {
        if (this._headerAndContentWrapperElement) {
            this._headerAndContentWrapperElement.style.transition = 'initial';
            this._headerAndContentWrapperElement.style.transform = 'translateY(0)';
        }
        this._contentOuterWrapperElement.style.animationName = '';
        this._contentInnerWrapperElement.style.animationName = '';
        this._toggleElement.classList.remove('expanded');
    };
    Dropdown.prototype.reset = function () {
        if (this._headerAndContentWrapperElement) {
            this._headerAndContentWrapperElement.style.transition = '';
            this._headerAndContentWrapperElement.style.transform = '';
        }
        this._contentOuterWrapperElement.style.transform = '';
        this._contentInnerWrapperElement.style.transform = '';
        this._contentOuterWrapperElement.style.animationName = '';
        this._contentInnerWrapperElement.style.animationName = '';
        this._toggleElement.classList.remove('expanded');
    };
    Dropdown.prototype.isExpanded = function () {
        // Could have a private boolean for expanded/collapsed state, however, elements can be modified by other scripts, 
        // this seems like the lesser evil.
        return this._toggleElement.classList.contains('expanded');
    };
    Dropdown = __decorate([
        inversify_1.injectable(),
        __metadata("design:paramtypes", [HTMLElement,
            HTMLElement,
            HTMLElement,
            HTMLElement])
    ], Dropdown);
    return Dropdown;
}());
exports.default = Dropdown;
//# sourceMappingURL=dropdown.js.map