"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var inversify_1 = require("inversify");
// TODO would be much more performant if accordions could be built using just transforms
var HeightService = /** @class */ (function () {
    function HeightService() {
        var _this = this;
        this.setHeightAutoListener = function (event) {
            if (event.target === event.currentTarget) {
                event.target.removeEventListener('transitionend', _this.setHeightAutoListener, true);
                event.target.style.height = 'auto';
            }
            event.stopPropagation();
        };
    }
    HeightService.prototype.toggleHeightWithTransition = function (toggleHeightElement, toggleClassElement) {
        toggleHeightElement.removeEventListener('transitionend', this.setHeightAutoListener, true);
        if (toggleClassElement.classList.contains('expanded')) {
            this.autoHeightToFixedHeightWithTransition(toggleHeightElement, 0);
        }
        else {
            this.currentHeightToAutoHeightWithTransition(toggleHeightElement);
        }
        toggleClassElement.classList.toggle('expanded');
    };
    HeightService.prototype.toggleHeightWithoutTransition = function (toggleHeightElement, toggleClassElement) {
        toggleHeightElement.removeEventListener('transitionend', this.setHeightAutoListener, true);
        if (toggleClassElement.classList.contains('expanded')) {
            this.autoHeightToFixedHeightWithoutTransition(toggleHeightElement, 0);
        }
        else {
            this.currentHeightToAutoHeightWithoutTransition(toggleHeightElement);
        }
        toggleClassElement.classList.toggle('expanded');
    };
    HeightService.prototype.contractHeightWithoutTransition = function (toggleHeightElement, toggleClassElement) {
        toggleHeightElement.removeEventListener('transitionend', this.setHeightAutoListener, true);
        this.autoHeightToFixedHeightWithoutTransition(toggleHeightElement, 0);
        toggleClassElement.classList.remove('expanded');
    };
    HeightService.prototype.expandHeightWithoutTransition = function (toggleHeightElement, toggleClassElement) {
        toggleHeightElement.removeEventListener('transitionend', this.setHeightAutoListener, true);
        this.currentHeightToAutoHeightWithoutTransition(toggleHeightElement);
        toggleClassElement.classList.add('expanded');
    };
    HeightService.prototype.reset = function (toggleHeightElement, toggleClassElement) {
        toggleHeightElement.style.height = 'auto';
        toggleClassElement.classList.remove('expanded');
    };
    HeightService.prototype.currentHeightToAutoHeightWithTransition = function (element) {
        var initialHeight = element.clientHeight;
        // Get auto height
        element.style.height = 'auto';
        var autoHeight = element.clientHeight;
        // Reset to initial height
        element.style.height = initialHeight + "px";
        // Trigger layout
        element.clientHeight;
        // Set auto height
        element.style.height = autoHeight + "px";
        element.addEventListener('transitionend', this.setHeightAutoListener, true);
    };
    HeightService.prototype.currentHeightToAutoHeightWithoutTransition = function (element) {
        element.style.height = 'auto';
    };
    HeightService.prototype.autoHeightToFixedHeightWithTransition = function (element, fixedHeight) {
        var initialHeight = element.clientHeight;
        // Set initial height
        element.style.height = initialHeight + "px";
        // Trigger layout
        element.clientHeight;
        // Set fixed height
        element.style.height = fixedHeight + "px";
    };
    HeightService.prototype.autoHeightToFixedHeightWithoutTransition = function (element, fixedHeight) {
        element.style.height = fixedHeight + "px";
    };
    HeightService = __decorate([
        inversify_1.injectable()
    ], HeightService);
    return HeightService;
}());
exports.default = HeightService;
//# sourceMappingURL=heightService.js.map