"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var inversify_1 = require("inversify");
var mediaWidth_1 = require("./mediaWidth");
var MediaGlobalService = /** @class */ (function () {
    function MediaGlobalService() {
        var _this = this;
        this.updateMediaWidth = function () {
            var newMediaWidth = mediaWidth_1.MediaWidth.medium;
            if (_this._narrowMediaQueryList.matches) {
                newMediaWidth = mediaWidth_1.MediaWidth.narrow;
            }
            else if (_this._wideMediaQueryList.matches) {
                newMediaWidth = mediaWidth_1.MediaWidth.wide;
            }
            if (newMediaWidth !== _this._mediaWidth) {
                _this._previousMediaWidth = _this._mediaWidth;
                _this._mediaWidth = newMediaWidth;
                return true;
            }
            return false;
        };
        // MediaQueryLists fire their listeners when their match status changes. Chrome and firefox both fire the listeners before the corresponding resize event. However, edge fires the listeners after the 
        // corresponding resize event. Therefore, MediaGlobalService cannot depend on MediaQueryList listeners to update _mediaWidth.
        this.onResizeListener = function () {
            if (_this.updateMediaWidth()) {
                var changeFromListeners = _this._onMediaWidthChangeListeners[_this._previousMediaWidth * 2 + 1];
                for (var i = 0; i < changeFromListeners.length; i++) {
                    changeFromListeners[i](false);
                }
                var changeToListeners = _this._onMediaWidthChangeListeners[_this._mediaWidth * 2];
                for (var i = 0; i < changeToListeners.length; i++) {
                    changeToListeners[i](false);
                }
            }
        };
    }
    MediaGlobalService.prototype.setupImmediate = function () {
        this._narrowMediaQueryList = window.matchMedia('(max-width: 855px)');
        this._wideMediaQueryList = window.matchMedia('(min-width: 1184px)');
        this.updateMediaWidth();
        this._onMediaWidthChangeListeners = [];
        // TODO cleaner way to get number of listener arrays (in case more media widths are added)
        for (var i = 0; i <= mediaWidth_1.MediaWidth.wide * 2 + 1; i++) {
            this._onMediaWidthChangeListeners[i] = [];
        }
        window.addEventListener('resize', this.onResizeListener);
    };
    MediaGlobalService.prototype.setupOnDomContentLoaded = function () {
    };
    MediaGlobalService.prototype.setupOnLoad = function () {
    };
    MediaGlobalService.prototype.addChangedToListener = function (listener, mediaWidth) {
        var listeners = this._onMediaWidthChangeListeners[mediaWidth * 2];
        listeners.push(listener);
        if (this._mediaWidth === mediaWidth) {
            listener(true);
        }
    };
    MediaGlobalService.prototype.addChangedFromListener = function (listener, mediaWidth) {
        var listeners = this._onMediaWidthChangeListeners[mediaWidth * 2 + 1];
        listeners.push(listener);
        if (this._mediaWidth !== mediaWidth) {
            listener(true);
        }
    };
    MediaGlobalService.prototype.mediaWidthIs = function (mediaWidth) {
        return this._mediaWidth === mediaWidth;
    };
    MediaGlobalService.prototype.mediaWidthChanged = function () {
        return this._mediaWidth !== this._previousMediaWidth;
    };
    MediaGlobalService.prototype.getPreviousMediaWidth = function () {
        return this._previousMediaWidth;
    };
    MediaGlobalService = __decorate([
        inversify_1.injectable()
    ], MediaGlobalService);
    return MediaGlobalService;
}());
exports.default = MediaGlobalService;
//# sourceMappingURL=mediaGlobalService.js.map