"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var inversify_1 = require("inversify");
var PaginationService = /** @class */ (function () {
    function PaginationService() {
    }
    PaginationService.prototype.setupPagination = function (buttonsParentElement, itemsParentElement, items, onDomReady, numPerPage, numPageButtons) {
        var _this = this;
        if (onDomReady === void 0) { onDomReady = null; }
        if (numPerPage === void 0) { numPerPage = 5; }
        if (numPageButtons === void 0) { numPageButtons = 5; }
        // Check if setup before with other items
        var setupBefore = buttonsParentElement.children.length > 2;
        // Calculate number of pages
        var numPages = Math.ceil(items.length / numPerPage);
        // Current page number
        var currentPageNumber = 1;
        // Page buttons
        numPageButtons = Math.min(numPages, numPageButtons);
        var pageButtonElements = [];
        var masterAnchorElement = document.createElement('a');
        masterAnchorElement.setAttribute('href', '#'); // Ensures that pages scrolls to top on click
        var masterPageButton = document.createElement('li');
        masterPageButton.appendChild(masterAnchorElement);
        // Pagination buttons
        var prevButtonElement = buttonsParentElement.querySelector('.pagination-prev');
        var nextButtonElement = buttonsParentElement.querySelector('.pagination-next');
        if (setupBefore) {
            // Reset if setup before
            prevButtonElement = prevButtonElement.cloneNode(true); // Clone to get rid of existing listeners
            nextButtonElement = nextButtonElement.cloneNode(true); // Clone to get rid of existing listeners
            buttonsParentElement.innerHTML = ''; // Clear existing buttons
            buttonsParentElement.appendChild(prevButtonElement);
            buttonsParentElement.appendChild(nextButtonElement);
        }
        prevButtonElement.
            querySelector('a').
            addEventListener('click', function () {
            currentPageNumber = currentPageNumber > 1 ? currentPageNumber - 1 : 1;
            _this.render(currentPageNumber, numPerPage, items, itemsParentElement, pageButtonElements, prevButtonElement, nextButtonElement, onDomReady);
        });
        nextButtonElement.
            querySelector('a').
            addEventListener('click', function () {
            currentPageNumber = currentPageNumber < numPages ? currentPageNumber + 1 : numPages;
            _this.render(currentPageNumber, numPerPage, items, itemsParentElement, pageButtonElements, prevButtonElement, nextButtonElement, onDomReady);
        });
        for (var j = 0; j < numPageButtons; j++) {
            var pageButtonElement = masterPageButton.cloneNode(true);
            pageButtonElement.querySelector('a').addEventListener('click', function (event) {
                currentPageNumber = parseInt(event.currentTarget.textContent);
                _this.render(currentPageNumber, numPerPage, items, itemsParentElement, pageButtonElements, prevButtonElement, nextButtonElement, onDomReady);
            });
            pageButtonElements.push(pageButtonElement);
            buttonsParentElement.insertBefore(pageButtonElement, nextButtonElement);
        }
        // Initial render
        this.render(currentPageNumber, numPerPage, items, itemsParentElement, pageButtonElements, prevButtonElement, nextButtonElement, onDomReady);
    };
    PaginationService.prototype.render = function (pageNum, numPerPage, items, itemsParentElement, pageButtonElements, prevButtonElement, nextButtonElement, onDomReady) {
        if (onDomReady === void 0) { onDomReady = null; }
        // Snippets
        var start = (pageNum - 1) * numPerPage;
        var currentItems = [].slice.call(items, start, start + numPerPage);
        while (itemsParentElement.firstChild) {
            itemsParentElement.removeChild(itemsParentElement.firstChild);
        }
        for (var i = 0; i < currentItems.length; i++) {
            var item = currentItems[i];
            itemsParentElement.appendChild(item);
        }
        // Buttons
        var numPages = Math.ceil(items.length / numPerPage);
        var numButtons = pageButtonElements.length;
        var middleButtonNum = Math.round(numButtons / 2);
        // First button number
        var firstButtonNum = 0;
        if (pageNum < middleButtonNum) {
            firstButtonNum = 1;
        }
        else if (numPages - pageNum < middleButtonNum) {
            firstButtonNum = numPages - numButtons + 1;
        }
        else {
            firstButtonNum = pageNum - middleButtonNum + 1;
        }
        // Prev/next buttons
        if (pageNum == 1) {
            prevButtonElement.classList.add('disabled');
        }
        else {
            prevButtonElement.classList.remove('disabled');
        }
        if (pageNum == numPages) {
            nextButtonElement.classList.add('disabled');
        }
        else {
            nextButtonElement.classList.remove('disabled');
        }
        for (var i = 0; i < numButtons; i++) {
            var buttonNum = firstButtonNum + i;
            var pageButtonElement = pageButtonElements[i];
            if (buttonNum == pageNum) {
                pageButtonElement.classList.add('active');
            }
            else {
                pageButtonElement.classList.remove('active');
            }
            pageButtonElement.querySelector('a').textContent = buttonNum.toString();
        }
        if (onDomReady) {
            onDomReady();
        }
    };
    PaginationService = __decorate([
        inversify_1.injectable()
    ], PaginationService);
    return PaginationService;
}());
exports.default = PaginationService;
//# sourceMappingURL=paginationService.js.map