"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var inversify_1 = require("inversify");
// Root components correspond to the direct children of <body> and <div id="core">. 
// These components are typically independent of each other and are typically the roots of logical groups of interelated sub-components.
var RootComponent = /** @class */ (function () {
    function RootComponent() {
    }
    RootComponent.prototype.addChildComponents = function () {
        var components = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            components[_i] = arguments[_i];
        }
        this.childComponents = components;
    };
    RootComponent.prototype.childComponentsSetupImmediate = function () {
        for (var i = 0; i < this.childComponents.length; i++) {
            this.childComponents[i].setupImmediate();
        }
    };
    RootComponent.prototype.childComponentsSetupOnDomContentLoaded = function () {
        for (var i = 0; i < this.childComponents.length; i++) {
            this.childComponents[i].setupOnDomContentLoaded();
        }
    };
    RootComponent.prototype.childComponentsSetupOnLoad = function () {
        for (var i = 0; i < this.childComponents.length; i++) {
            this.childComponents[i].setupOnLoad();
        }
    };
    RootComponent = __decorate([
        inversify_1.injectable()
    ], RootComponent);
    return RootComponent;
}());
exports.default = RootComponent;
//# sourceMappingURL=rootComponent.js.map